//##################################################################
// SimpleExpressions
//##################################################################

#include SimpleExpressions.h

/*
#define DEBUGEXE "C:\Programming\RadASM3\GoAsm\dbg\DbgWin.exe"
#define DBG64LIB "C:\Programming\RadASM3\GoAsm\dbg\Debug64.lib"
#define DBG32LIB "C:\Programming\RadASM3\GoAsm\Projects\Debug32\Debug32.lib"
#IF X64
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug64.a"
#ELSE
	#define PRESERVEXMMREGS
	#include "C:\Programming\RadASM3\GoAsm\dbg\Debug32.a"
#ENDIF
*/

// Symbols require a debug build:
// GoAsm /c /x86 "project.Asm"
// GoLink "project.obj"   /Debug dbg

// operators
// |,&,^,*,/,+,-,!,(,)
// comparisons
// !=,!<,!>,<>,>=,<=,=,<,>

// use signed multiply and divide
#define SIGNEDOP

REGISTERS STRUCT
	Eax DD
	Ebx DD
	Ecx DD
	Edx DD
	Esi DD
	Edi DD
	Ebp DD
	Esp DD
ENDS

#define STACKSIZE 60
#define CALC_FAIL -2
#define CALC_SUCCESS -1
#define CALC_DIVBYZERO -3
#define CALC_OVERFLOW -4
#define CALC_SYMNOTFOUND -5

// enum DATATYPE_TAG
DATATYPE_DEFAULT = -1
DATATYPE_BYTE = 0
DATATYPE_WORD = 1
DATATYPE_DWORD = 2
DATATYPE_QWORD = 3

// enum CALC_SYMBOLS_TAG
CALC_SYMBOL_OR=0 // |
CALC_SYMBOL_AND=1 // &
CALC_SYMBOL_XOR=2 // ^
CALC_SYMBOL_MULTIPLY=3 // *
CALC_SYMBOL_DIVIDE=4 // /
CALC_SYMBOL_ADD=5 // +
CALC_SYMBOL_SUBTRACT=6 // -
CALC_SYMBOL_NOT=7 // !
CALC_SYMBOL_OPEN=8  // (
CALC_SYMBOL_CLOSE=9 // )
CALC_SYMBOL_NUMBER=10
CALC_SYMBOL_INVALID=11

STACKENTRY STRUCT
	var INT32
	sym ENUM // CALC_SYMBOLS
ENDS

SaveRegisters(%1) macro
	mov [%1.Eax],eax
	mov [%1.Ebx],ebx
	mov [%1.Ecx],ecx
	mov [%1.Edx],edx
	mov [%1.Esi],esi
	mov [%1.Edi],edi
	mov [%1.Ebp],ebp
	mov [%1.Esp],esp
endm

RestoreRegisters(%1) macro
	mov eax,[%1.Eax]
	mov ebx,[%1.Ebx]
	mov ecx,[%1.Ecx]
	mov edx,[%1.Edx]
	mov esi,[%1.Esi]
	mov edi,[%1.Edi]
	mov ebp,[%1.Ebp]
	mov esp,[%1.Esp]
endm

CONST SECTION
align 16
lcase:
	db   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15
	db  16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31
	db  32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47
	db  48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63
	db  64, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
	db 112,113,114,115,116,117,118,119,120,121,122, 91, 92, 93, 94, 95
	db  96, 97, 98, 99,100,101,102,103,104,105,106,107,108,109,110,111
	db 112,113,114,115,116,117,118,119,120,121,122,123,124,125,126,127
	db 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
	db 144,145,146,147,148,149,150,151,152,153,154,155,156,156,158,159
	db 160,161,162,163,164,165,166,167,168,169,170,171,172,173,173,175
	db 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
	db 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
	db 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
	db 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
	db 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255

DATA SECTION
	hInstance DD 0xFF01
	hInstance2 DD 0xFF02
	StackIndex DD 0
	solution DD 0
	szSolution DB 256 DUP (?)
	StackBuffer STACKENTRY STACKSIZE DUP <0,0>

	ALIGN 16
	ctxt REGISTERS <>

CODE SECTION

START:
mov ebx,16
SaveRegisters(ctxt)
invoke Assert,"ebx!=15+2"
test eax,eax
js >
	invoke dw2a,eax,offset szSolution
	invoke MessageBox,NULL,offset szSolution,"Solution",NULL
:

// Left to right only no precedence
invoke calculate,"EBX",offset solution
cmp eax,CALC_SUCCESS
jne >
	invoke dw2a,[solution],offset szSolution
	invoke MessageBox,NULL,offset szSolution,"Solution",NULL
:
RestoreRegisters(ctxt)

invoke ExitProcess,0

// Finally the assert function
Assert FRAME pExpr
	uses edi,esi,ebx
	LOCAL LeftResult:D
	LOCAL RightResult:D
	LOCAL LeftSide[128]:B
	LOCAL RightSide[128]:B

	// zero the buffers
	mov edi,offset LeftSide
	mov ecx,128
	mov eax,0
	rep stosb
	mov edi,offset RightSide
	mov ecx,128
	mov eax,0
	rep stosb

	// See if the expression has 2 parts
	mov esi,[pExpr]
	xor ebx,ebx
	dec ebx
	:
	inc ebx
	mov ax,[esi+ebx]
	cmp ax,"!="
	je >>.NOTEQUAL
	cmp ax,"<>"
	je >>.NOTEQUAL
	cmp ax,"!<"
	je >>.NOTLESS
	cmp ax,"!>"
	je >>.NOTGREATER
	cmp ax,">="
	je >>.NOTLESS
	cmp ax,"<="
	je >>.NOTGREATER
	cmp al,"="
	je >>.EQUAL
	cmp al,"<"
	je >>.LESS
	cmp al,">"
	je >>.GREATER
	cmp al,0
	jne <

	.ONEPART
	// Solve the expresssion return TRUE, FALSE or FAIL
	invoke calculate,[pExpr],offset LeftResult
	cmp eax,CALC_SUCCESS
	jne >>.FAIL
	mov eax,TRUE
	cmp D[LeftResult],0
	jne >
	mov eax,FALSE
	:
	ret

	// Split the expression and solve each part separately
	.NOTEQUAL
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (2 bytes)
		add esi,2
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if not equal
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		je >
		mov eax,TRUE
		:
		ret

	.NOTGREATER
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (2 bytes)
		add esi,2
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if not greater
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		jle >
			mov eax,TRUE
		:
		ret


	.NOTLESS
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (2 bytes)
		add esi,2
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if not less
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		jge >
			mov eax,TRUE
		:
		ret

	.EQUAL
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (1 bytes)
		inc esi
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if equal
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		jne >
			mov eax,TRUE
		:
		ret

	.LESS
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (1 bytes)
		inc esi
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if less
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		jge >
			mov eax,TRUE
		:
		ret

	.GREATER
		// Copy the left side
		mov ecx,ebx
		mov edi,offset LeftSide
		rep movsb
		// Copy the right side - skip past the equate operator (1 bytes)
		inc esi
		xor ecx,ecx
		dec ecx
		mov edi,offset RightSide
		:
			inc ecx
			mov al,[esi+ecx]
			test al,al
			jz >
			mov [edi+ecx],al
			jmp <
		:
		inc ecx
		mov B[edi+ecx],0
		invoke calculate,offset LeftSide,offset LeftResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		invoke calculate,offset RightSide,offset RightResult
		cmp eax,CALC_SUCCESS
		jne >>.FAIL
		// Return TRUE if greater
		// False otherwise
		mov eax,FALSE
		mov edx,[LeftResult]
		mov ecx,[RightResult]
		cmp edx,ecx
		jle >
			mov eax,TRUE
		:
		ret

	.FAIL
	// Return whatever error the calculate function returned
	ret
endf

lszCmpi FRAME pString1,pString2
	uses ebx,esi,edi

	lea ebx,lcase
	mov edi, [pString1]
	mov esi, [pString2]
	:
	mov al, [esi]
	xlatb
	mov ah,al
	mov al, [edi]
	xlatb
	add esi,1
	add edi,1
	sub al, ah
	jnz >
	or ah, ah
	jnz <
	:
	movsx eax, al
	ret

ENDF

dw2a FRAME dwValue,lpBuffer
	uses ebx,edi

	; MichaelW w/ PDixon

		mov eax,[dwValue]
		mov ecx,2814749768
		mov edi,[lpBuffer]

		or eax,eax
		jns >S1
		neg eax
		mov B[edi],"-"
		inc edi

S1:
	push eax
;	#####fast div by 100000
		mul ecx
		mov ecx,100000
		shr edx,16
		mov eax,edx
		mov ebx,edx
		mul ecx
	sub [esp],eax

		mov eax,ebx
		mov ecx,429497
		mov ebx,10

		or eax,eax
		jz >S5

;	#######part 1
		mul ecx
		jc >D1

		mul ebx
		jc >D2

		mul ebx
		jc >D3

		mul ebx
		jc >D4

		mul ebx
		jc >D5
S5:
	pop eax
		mul ecx
		jc >D6

		mul ebx
		jc >D7

		mul ebx
		jc >D8

		mul ebx
		jc >D9

		mul ebx
		jmp >D0

;	#####end part1

D1:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D2:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D3:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D4:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D5:
		add edx,30h
		mov [edi],dl

	pop eax

		mul ecx
		inc edi
D6:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D7:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D8:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D9:
		add edx,30h
		mov [edi],dl

		mul ebx
		inc edi
D0:
		add edx,30h
		mov [edi],dx

	mov eax,[dwValue]
	RET
ENDF

a2dw FRAME lpBuffer
	uses esi

	mov esi, [lpBuffer]
	cmp B[esi],"-"
	jne  >S1
		inc esi
		xor eax,eax
		xor edx,edx
		jmp >N1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		N1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		neg eax
		ret

	S1:
		xor eax,eax
		xor edx,edx
		jmp >P1
		:
		lea eax,[eax*4+eax]
		lea eax,[eax*2+edx]
		P1:
		mov dl,[esi]
		inc esi
		sub dl,"0"
		jns <
		ret
ENDF

eval_push FRAME p1
	cmp D[StackIndex],STACKSIZE
	jge >.ERROR
		mov ecx,[StackIndex]
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]
		mov eax,[edx+STACKENTRY.var]
		mov [ecx+STACKENTRY.var],eax
		mov eax,[edx+STACKENTRY.sym]
		mov [ecx+STACKENTRY.sym],eax

		inc D[StackIndex]
		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_pop FRAME p1
	cmp D[StackIndex],0
	jle >>.ERROR
		dec D[StackIndex]
		mov ecx,[StackIndex]
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]

		mov eax,[ecx+STACKENTRY.var]
		mov [edx+STACKENTRY.var],eax
		mov eax,[ecx+STACKENTRY.sym]
		mov [edx+STACKENTRY.sym],eax

		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_peek FRAME p1
	cmp D[StackIndex],0
	jle >>.ERROR

		mov ecx,[StackIndex]
		dec ecx
		shl ecx,3 // Multiply by 8 (SIZEOF STACKENTRY)
		add ecx,offset StackBuffer
		mov edx,[p1]

		mov eax,[ecx+STACKENTRY.var]
		mov [edx+STACKENTRY.var],eax
		mov eax,[ecx+STACKENTRY.sym]
		mov [edx+STACKENTRY.sym],eax

		mov eax,1
		ret
	.ERROR
	mov eax,0
	ret
endf

eval_initstack:
	push edi
	mov ecx,STACKSIZE
	shl ecx,3
	mov edi,offset StackBuffer
	mov eax,0
	rep stosb
	pop edi
	mov D[StackIndex],0
	ret

eval_binary_op FRAME sym
	LOCAL temp:STACKENTRY

	cmp D[StackIndex],1
	jge >
		mov eax,CALC_FAIL
		ret
	:
	invoke eval_peek,offset temp
	cmp D[temp.sym],CALC_SYMBOL_NUMBER
	je >
		mov eax,CALC_FAIL
		ret
	:
	mov eax,[sym]
	mov [temp.sym],eax
	invoke eval_push,offset temp
	test eax,eax
	jnz >
		mov eax,CALC_FAIL
		ret
	:
	mov eax,CALC_SUCCESS
	ret
endf

eval_unary_op FRAME sym
	LOCAL temp:STACKENTRY

	mov eax,[sym]
	mov [temp.sym],eax

	invoke eval_push,offset temp
	test eax,eax
	jnz >
		mov eax,CALC_FAIL
		ret
	:

	mov eax,CALC_SUCCESS
	ret
endf

eval_paren FRAME sym
	uses ebx
	LOCAL temp:STACKENTRY
	LOCAL result:D

	mov ebx,[sym]
	cmp ebx,CALC_SYMBOL_OPEN
	jne >.CALC_SYMBOL_CLOSE
		mov [temp.sym],ebx
		invoke eval_push,offset temp
		test eax,eax
		jz >>.ERROR
		mov eax,CALC_SUCCESS
		ret

	.CALC_SYMBOL_CLOSE
	cmp ebx,CALC_SYMBOL_CLOSE
	jne >.ERROR
		invoke eval_pop,offset temp
		test eax,eax
		jz >>.ERROR
		cmp D[temp.sym],CALC_SYMBOL_NUMBER
		jne >>.ERROR
		mov eax,[temp.var]
		mov [result],eax
		invoke eval_pop,offset temp
		test eax,eax
		jz >>.ERROR
		cmp D[temp.sym],CALC_SYMBOL_OPEN
		jne >>.ERROR
		invoke eval_number,[result]
		cmp eax,CALC_SUCCESS
		jne >>.ERROR
		mov eax,CALC_SUCCESS
		ret

	.ERROR
	mov eax,CALC_FAIL
	ret
endf

eval_number FRAME num
	uses ebx
	LOCAL temp:STACKENTRY
	LOCAL precede:D // CALC_SYMBOLS
	LOCAL result:D
	
	cmp D[StackIndex],1
	jge >
		mov eax,[num]
		mov [temp.var],eax
		mov D[temp.sym],CALC_SYMBOL_NUMBER
		invoke eval_push,offset temp
		mov eax,CALC_SUCCESS
		ret
	:
	
	invoke eval_peek,offset temp
	mov ebx,[temp.sym]
	mov [precede],ebx
	
	cmp ebx,CALC_SYMBOL_NOT
	jge >>.CALC_SYMBOL_NOT
		// OR,AND,XOR,*,/,+,-
		invoke eval_pop,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		invoke eval_pop,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		cmp D[temp.sym],CALC_SYMBOL_NUMBER
		je >
			mov eax,CALC_FAIL
			ret
		:
		// Now the calculation
		cmp ebx,CALC_SYMBOL_OR
		jne >.CALC_SYMBOL_AND
			mov eax,[temp.var]
			mov ecx,[num]
			or eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_AND
		cmp ebx,CALC_SYMBOL_AND
		jne >.CALC_SYMBOL_XOR
			mov eax,[temp.var]
			mov ecx,[num]
			and eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND
		
		.CALC_SYMBOL_XOR
		cmp ebx,CALC_SYMBOL_XOR
		jne >.CALC_SYMBOL_MULTIPLY
			mov eax,[temp.var]
			mov ecx,[num]
			xor eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND
		
		.CALC_SYMBOL_MULTIPLY
		cmp ebx,CALC_SYMBOL_MULTIPLY
		jne >.CALC_SYMBOL_DIVIDE
			mov eax,[temp.var]
			mov ecx,[num]
			xor edx,edx
			#IFDEF SIGNEDOP
				imul eax,ecx
			#ELSE
				mul ecx
			#ENDIF
			test edx,edx
			jz >
				mov eax,CALC_OVERFLOW
				ret
			:
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_DIVIDE
		cmp ebx,CALC_SYMBOL_DIVIDE
		jne >>.CALC_SYMBOL_ADD
			cmp D[num],0
			jne >
				mov eax,CALC_DIVBYZERO
				ret
			:
			mov eax,[temp.var]
			mov ecx,[num]
			xor edx,edx
			#IFDEF SIGNEDOP
			idiv ecx
			#ELSE
			div ecx
			#ENDIF
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_ADD
		cmp ebx,CALC_SYMBOL_ADD
		jne >.CALC_SYMBOL_SUBTRACT
			mov eax,[temp.var]
			mov ecx,[num]
			add eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALC_SYMBOL_SUBTRACT
		cmp ebx,CALC_SYMBOL_SUBTRACT
		jne >>.DEFAULT
			mov eax,[temp.var]
			mov ecx,[num]
			sub eax,ecx
			mov [temp.var],eax
			jmp >>.CALCEND

		.CALCEND
			// Push the result onto the stack
			mov D[temp.sym],CALC_SYMBOL_NUMBER
			invoke eval_push,offset temp
			test eax,eax
			jnz >
				mov eax,CALC_FAIL
				ret
			:
			mov eax,CALC_SUCCESS
			ret

	.CALC_SYMBOL_NOT
	cmp ebx,CALC_SYMBOL_NOT
	jne >>.CALC_SYMBOL_OPEN
		invoke eval_pop,offset temp
		mov D[result],TRUE
		cmp D[num],0
		je >
			mov D[result],FALSE
		:
		invoke eval_number,[result]
		ret

	.CALC_SYMBOL_OPEN
	cmp ebx,CALC_SYMBOL_OPEN
	jne >>.CALC_SYMBOL_CLOSE
		mov eax,[num]
		mov [temp.var],eax
		mov D[temp.sym],CALC_SYMBOL_NUMBER
		invoke eval_push,offset temp
		test eax,eax
		jnz >
			mov eax,CALC_FAIL
			ret
		:
		mov eax,CALC_SUCCESS
		ret

	.CALC_SYMBOL_CLOSE
	cmp ebx,CALC_SYMBOL_CLOSE
	jne >>.CALC_SYMBOL_NUMBER
		// Not possible
		mov eax,CALC_FAIL
		ret

	.CALC_SYMBOL_NUMBER
	cmp ebx,CALC_SYMBOL_NUMBER
	jne >>.DEFAULT
		// Not possible
		mov eax,CALC_FAIL
		ret

	.DEFAULT
		mov eax,CALC_FAIL
		ret

	ret
endf

calculate FRAME exp,result
	uses edi,esi,ebx
	LOCAL temp:STACKENTRY
	LOCAL szNumber[64]:B

	call eval_initstack
	
	mov edi,[exp]
	test edi,edi
	jnz >
		// bad pointer return 0
		mov eax,0
		ret
	:
	mov eax,[edi]
	test eax,eax
	jnz >
		// empty string
		mov eax,0
		ret
	:
	// set the index to zero
	xor ebx,ebx
	dec ebx
	.WALKEXPRESSION
		inc ebx
		mov esi,[edi+ebx]
		mov ecx,esi
		and esi,0xff
		test esi,esi
		jz >>.ENDWALK

		.OR
		cmp esi,'|'
		jne >>.AND
			invoke eval_binary_op,CALC_SYMBOL_OR
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			// If it fails return the index
			mov eax,ebx
			ret

		.AND
		cmp esi,'&'
		jne >>.XOR
			invoke eval_binary_op,CALC_SYMBOL_AND
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.XOR
		cmp esi,'^'
		jne >>.NOT
			invoke eval_binary_op,CALC_SYMBOL_XOR
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.NOT
		cmp esi,'!'
		jne >>.OPEN
			invoke eval_unary_op,CALC_SYMBOL_NOT
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.OPEN
		cmp esi,'('
		jne >>.CLOSE
			invoke eval_paren,CALC_SYMBOL_OPEN
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.CLOSE
		cmp esi,')'
		jne >>.MULTIPLY
			invoke eval_paren,CALC_SYMBOL_CLOSE
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.MULTIPLY
		cmp esi,'*'
		jne >>.DIVIDE
			invoke eval_binary_op,CALC_SYMBOL_MULTIPLY
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.DIVIDE
		cmp esi,'/'
		jne >>.ADD
			invoke eval_binary_op,CALC_SYMBOL_DIVIDE
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.ADD
		cmp esi,'+'
		jne >>.SUBTRACT
			invoke eval_binary_op,CALC_SYMBOL_ADD
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.SUBTRACT
		cmp esi,'-'
		jne >>.SPACE
			cmp D[StackIndex],0
			je >>.NUMBER
			invoke eval_peek,offset temp
			cmp D[temp.sym],CALC_SYMBOL_NUMBER
			jne >>.NUMBER
			invoke eval_binary_op,CALC_SYMBOL_SUBTRACT
			cmp eax,CALC_FAIL
			jne <<.WALKEXPRESSION
			mov eax,ebx
			ret

		.SPACE
		cmp esi," "
		je <<.WALKEXPRESSION

		.TAB
		cmp esi,9
		je <<.WALKEXPRESSION

		.NUMBER
			mov eax,offset szNumber
			cmp esi,"-"
			jne >
				mov B[eax],"-"
				inc eax
				inc ebx
				mov esi,[edi+ebx]
				and esi,0xff
			:
			cmp esi,0x30
			jl >>.SYMBOL
			cmp esi,0x39
			jg >>.SYMBOL
			// we have a number copy it to the buffer
				:
				mov cl,[edi+ebx]
				cmp cl,0x39
				jg >
				cmp cl,0x30
				jl >
				mov [eax],cl
				inc ebx
				inc eax
				jmp <
				:
			dec ebx
			mov B[eax],0
			invoke a2dw,offset szNumber
			invoke eval_number,eax
			cmp eax,CALC_SUCCESS

			je <<.WALKEXPRESSION
			mov ecx,[result]
			mov D[ecx],eax
			mov eax,ebx
			ret

		.SYMBOL
			// the first letter didn't match any of the normal expected ones
			// so we'll see if it's in the symbol table

			// Symbols must start with a letter
			// To get the full symbol name scan ahead until
			// we find an operator. This will be done in a subroutine
			// it will return CALC_SUCCESS if the symbol is found
			// CALC_FAIL if not found
			// The current value of the symbol is in temp.var
			// ecx will contain the count of characters in the symbol so
			// the index can be advanced
			lea eax,[edi+ebx]
			invoke ScanForSymbol, eax, offset temp
			cmp eax,CALC_FAIL
			jne >
				mov eax,CALC_SYMNOTFOUND
				ret
			:
			add ebx,ecx
			dec ebx
			invoke eval_number,[temp.var]
			cmp eax,CALC_SUCCESS
			je <<.WALKEXPRESSION

			mov ecx,[result]
			mov D[ecx],eax
			mov eax,ebx
			ret

		.INVALID
			mov eax,ebx
			ret

	.ENDWALK
	cmp D[StackIndex],1
	je >
		mov eax,ebx
		ret
	:
	invoke eval_pop,offset temp
	test eax,eax
	jnz >
		mov eax,ebx
		ret
	:
	cmp D[temp.sym],CALC_SYMBOL_NUMBER
	je >
		mov eax,ebx
		ret
	:
	mov eax,[result]
	mov ecx,[temp.var]
	mov [eax],ecx
	mov eax,CALC_SUCCESS
	ret
endf

ScanForSymbol FRAME pExpr, p1
	uses ebx,edi,esi
	LOCAL szSymbolName[256]:B
	LOCAL pSymbol:D
	LOCAL fByValue:D
	LOCAL DataType:D

	mov D[DataType],DATATYPE_DEFAULT

	// Optional type indicators (B,W,D) (BYTE,WORD and DWORD respectively)
	// types can only be used on bracketed labels []. Any other use will
	// cause the evaluation to fail. The open bracket must be immediately
	// following the type indicator, no spaces are allowed between them

	// Brackets are not allowed with registers (yet)

	// no brackets [] indicate that the address is to
	// be used instead of the value when dealing with symbols
	// registers will always return the value and cannot be
	// dereferenced (yet)

	mov D[fByValue],FALSE

	// Scan ahead to the next whitespace or operator
	mov edi,[pExpr]
	
	mov al,[edi]
	cmp al,"["
	jne >
		mov D[fByValue],TRUE
		inc edi
		jmp >>.BREAK
	:
	// B W D
	cmp al,"B"
	jne >
		mov al,[edi+1]
		cmp al,"["
		jne >
			mov D[fByValue],TRUE
			mov D[DataType],DATATYPE_BYTE
			add edi,2
			jmp >>.BREAK
	:
	cmp al,"W"
	jne >
		mov al,[edi+1]
		cmp al,"["
		jne >
			mov D[fByValue],TRUE
			mov D[DataType],DATATYPE_WORD
			add edi,2
			jmp >>.BREAK
	:
	cmp al,"D"
	jne >.BREAK
		mov al,[edi+1]
		cmp al,"["
		jne >.BREAK
			mov D[fByValue],TRUE
			mov D[DataType],DATATYPE_DWORD
			add edi,2
	.BREAK
	
	push edi
	xor ecx,ecx

	:
		mov al,[edi]
		inc edi
		inc ecx
		test al,al
		jz >
		cmp al,"+"
		je >
		cmp al,"-"
		je >
		cmp al,"*"
		je >
		cmp al,"/"
		je >
		cmp al,"&"
		je >
		cmp al,"|"
		je >
		cmp al,"^"
		je >
		cmp al,"!"
		je >
		cmp al," "
		je >
		cmp al,9
		je >
		cmp al,"]"
		jne <
	:

	pop esi // ESI points to the source string for movsb
	dec ecx // the last character is the delimiter, don't copy it
	push ecx // Save the length of the symbol for later
	lea edi,szSymbolName // EDI points to the destination string for movsb
	rep movsb // copy the symbol name to a temporary buffer
	mov B[edi],0 // NULL terminate the string

	// Check to see if the symbol is TRUE or FALSE
	// They are supported as FALSE = 0, TRUE = 1
	invoke lszCmpi,offset szSymbolName,"TRUE"
	test eax,eax
	jnz >
		pop ecx
		mov edx,[p1]
		mov D[edx+STACKENTRY.var],1
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"FALSE"
	jnz >
		pop ecx
		mov edx,[p1]
		mov D[edx+STACKENTRY.var],0
		mov eax,CALC_SUCCESS
		ret
	:

	// Scan for register names
	// Registers are saved in a context structure before calculate is called

	// 8 bit registers
	invoke lszCmpi,offset szSymbolName,"AL"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Eax]
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"BL"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebx]
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"CL"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ecx]
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"DL"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edx]
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"AH"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Eax]
		shr eax,8
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"BH"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebx]
		shr eax,8
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"CH"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ecx]
		shr eax,8
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"DH"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edx]
		shr eax,8
		and eax,0xFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:

	// 16 bit registers
	invoke lszCmpi,offset szSymbolName,"AX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Eax]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"BX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebx]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"CX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ecx]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"DX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edx]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"SI"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Esi]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"DI"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edi]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"SP"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Esp]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"BP"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebp]
		and eax,0xFFFF
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:

	// 32 bit registers
	invoke lszCmpi,offset szSymbolName,"EAX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Eax]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"EBX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebx]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"ECX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ecx]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"EDX"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edx]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"ESI"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Esi]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"EDI"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Edi]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"ESP"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Esp]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	invoke lszCmpi,offset szSymbolName,"EBP"
	jnz >
		pop ecx
		mov edx,[p1]
		mov eax,offset ctxt
		mov eax,[eax+REGISTERS.Ebp]
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:

	.SKIPSEARCH

	// We need the length of the symbol again so pop it into ECX
	pop ecx

	// ECX is preserved by the FindSymbolByName procedure
	// It will contain the length of the symbol to advance the
	// index in the calculate procedure
	invoke FindSymbolByName,-1,offset szSymbolName,offset pSymbol,ecx
	test eax,eax // Returns 0 for success, -1 if the sym isn't found
	js >>.ERROR
	mov eax,[pSymbol]
	cmp D[fByValue],FALSE
	je >
		// The value not the address is required, dereference it and
		// adjust the value of the character count to reflect it
		mov eax,[eax]
		add ecx,2 // skip over the two [] brackets
	:

	cmp D[DataType],DATATYPE_BYTE
	jne >
		mov edx,[p1]
		and eax,0xFF
		inc ecx
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	cmp D[DataType],DATATYPE_WORD
	jne >
		mov edx,[p1]
		and eax,0xFFFF
		inc ecx
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:
	cmp D[DataType],DATATYPE_DWORD
	jne >
		mov edx,[p1]
		inc ecx
		mov [edx+STACKENTRY.var],eax
		mov eax,CALC_SUCCESS
		ret
	:

	// DATATYPE_DEFAULT
	// Put the value into the structure and return success
	// On exit ECX will contain the character count
	mov edx,[p1]
	mov [edx+STACKENTRY.var],eax
	mov eax,CALC_SUCCESS
	ret

	.ERROR
	mov eax,CALC_FAIL
	ret
ENDF

FindSymbolByName FRAME hProcess,pszSymbol,ppAddress,lenSymbol
	uses ebx,edi,esi,ecx
	LOCAL pSymInfo:D
	LOCAL SymModInfo:IMAGEHLP_MODULE64

	invoke CoTaskMemAlloc,SIZEOF SYMBOL_INFO+MAX_SYM_NAME-4
	mov [pSymInfo],eax

	mov ebx,[lenSymbol]
	mov D[eax+SYMBOL_INFO.NameLen],ebx
	mov D[eax+SYMBOL_INFO.MaxNameLen],MAX_SYM_NAME
	mov D[eax+SYMBOL_INFO.SizeOfStruct],SIZEOF SYMBOL_INFO

	mov ebx,[pSymInfo]
	add ebx,SYMBOL_INFO.Name
	invoke lstrcpy,ebx,[pszSymbol]

	 // invade process, load all modules
	invoke SymInitialize,[hProcess],0, TRUE

	invoke SymFromName,[hProcess],ebx,[pSymInfo]
	test eax,eax
	jz >>.NOSYM
	mov eax,[pSymInfo]
	mov edx,[eax+SYMBOL_INFO.Address+4]
	mov eax,[eax+SYMBOL_INFO.Address]
	mov ecx,[ppAddress]
	mov [ecx],eax

	// Shut it down
	invoke SymCleanup,[hProcess]
	invoke CoTaskMemFree,[pSymInfo]

	xor eax,eax
	RET

	.NOSYM
	invoke SymCleanup,[hProcess]
	invoke CoTaskMemFree,[pSymInfo]
	mov ecx,[ppAddress]
	mov D[ecx],0
	xor eax,eax
	dec eax
	RET
endf
